// lab6ex.cpp : Lab 6 example
//

#include "stdafx.h"
#include <conio.h>
#include <iostream>
#include <string>
using namespace std;

const int N_YEARS = 5;    // number of years in  the simulation
const int N_ACRES = 10;   // number of acres in  the forest
const int N_ANIMALS = 3;  // number of kinds of animals
const int N_PLANTS = 3;  // number of kinds of plants
const int START_LIFEFORMS = 50;
// name strings, animals first, then plants
const string NAMES[] = {"chipmunk","squirrel","badger","birch","oak","spruce"};

// represents a single acre in the forest
class acre {
	public:
		acre();  // default constructor, fill with random counts

		void showState();
		void update();
		int getCount(string name);

	private:
		string animalNames[N_ANIMALS];
		string plantNames[N_PLANTS];

		int animals[N_ANIMALS];  // counts of the different animals
		int plants[N_PLANTS];    // counts of the different plants
};  // acre

// making this global made lifecounts() easier but
// the definition had to come after the class declaration
acre forest[N_ACRES];

// when an acre is created, fill in the starting values
acre::acre() {
	int i;
	// set up the animal names and initialize the data
	for(i=0; i < N_ANIMALS; i++){
		animalNames[i] = NAMES[i];
		animals[i] = rand() % START_LIFEFORMS;
	}
	// set up the plant names and initialize the data
	for(i=0; i < N_PLANTS; i++){
		plantNames[i] = NAMES[i+N_ANIMALS];
		plants[i] = rand() % START_LIFEFORMS;
	}
} // default constructor

// show the current values of the lifeforms in the acre
void 
acre::showState() {
	int i;
	for(i=0; i < N_ANIMALS; i++)	
		cout << animalNames[i] << " = " << animals[i] << " ";
	for(i=0; i < N_PLANTS; i++)	
		cout << plantNames[i] << " = " << plants[i] << " ";
	cout << endl;
} // showState

// change the values of the numbers of the lifeforms
void 
acre::update() {
	int i;
	// if there are less than 2 plants or animals, don't update
	// to avoid a divide by 0 error thanks to integer arithmetic
	for(i=0; i < N_ANIMALS; i++){
		if(animals[i] < 2) continue;  
		if((rand() % 2) == 1)  // coin flip
			animals[i] += rand() % (animals[i] / 2);
		else
			animals[i] -= rand() % (animals[i] / 2);
	}
	for(i=0; i < N_PLANTS; i++){
		if(plants[i] < 2) continue;
		if((rand() % 2) == 1)  // coin flip
			plants[i] += rand() % (plants[i] / 2);
		else
			plants[i] -= rand() % (plants[i] / 2);
	}
} // update

// translate the name into an index number and
// use that to get the number of lifeforms
int
acre::getCount(string name)
{
	int i;
	// first check if the name is legal
	for(i=0; i < (N_ANIMALS + N_PLANTS); i++) {
		if(NAMES[i] == name) break;
	}
	if(i == (N_ANIMALS + N_PLANTS)) return -1;  // bad name

	if(i < N_ANIMALS) {   // it's an animal
		return(animals[i]);
	}
	return plants[i - N_ANIMALS];  // it's a plant
} // getCount

// used to record the before and after counts for the extra credit.
// Not ideal, depends on global forest array
class status {
		public:
			status() {
				for(int i=0; i < (N_ANIMALS + N_PLANTS); i++) totals[i] = 0;
			}
			void getstatus();
			void printstatus();
			int getcount(int i) { return totals[i];}
		private:
			int totals[N_ANIMALS + N_PLANTS];
};

void
status::getstatus()
{
	int i,j;
	for(i=0; i < (N_ANIMALS + N_PLANTS); i++) {
		for(j=0; j < N_ACRES; j++) {
			totals[i] += forest[j].getCount(NAMES[i]);
		}
	}
} // getstatus

void
status::printstatus()
{
	for(int i=0; i < (N_ANIMALS + N_PLANTS); i++) {
		cout << NAMES[i] << " --> " << totals[i] << endl;
	}
} // printstatus

// used in several places
void
wait()
{
	char c;
	cout << "Hit enter to go on ";
	c= _getche();
	cout << endl;
} // wait

int main(int argc, char* argv[])
{
	int i,j,k;
	status before, after;

	// show the initial state
	for(i=0; i < N_ACRES; i++)  {
		cout << "Acre:" << i << " ";
		forest[i].showState();
	}
	cout << "initial life form report" << endl;
	before.getstatus();
	before.printstatus();
	wait();

	// main year loop
	for(j = 0; j < N_YEARS; j++) {
		cout << "Year: " << j << endl;
		for(k=0; k < N_ACRES; k++)  {
			forest[k].update();
			cout << "Acre:" << k << " ";
			forest[k].showState();
		}
		wait();
	} // year loop

	cout << "Final life form report" << endl;
	after.getstatus();
	after.printstatus();
	wait();

	cout << "The difference between the before and after is " << endl;
	for(i=0; i < (N_ANIMALS + N_PLANTS); i++) {
		cout << NAMES[i] << " --> " << after.getcount(i) - before.getcount(i) << endl;
	}

	return 0;
}
